//vc/ VC/m Change Request Selection
//vc/ Copyright 2001,2003 George James
//vc/ Object:    ChangeRequestSelect.js/1
//vc/ Component: T.ChangeRequestSelect.js


	var delimiter='\001';
	var winHelp=null;
	var winHelpProperties=parent.opener.winHelpProperties;
	var user=parent.opener.user;
	
	// Indicates the currently selected row
	var g_oSelectedRow=null;


function fnClose() {
	fnCloseNotify();
}

function fnCloseNotify() {
	if (GjsTableSorter.g_oCurrentSortButton) {
		arguments = GjsTableSorter.g_oCurrentSortButton.textContent;
		arguments += delimiter + (getAttr(GjsTableSorter.g_oCurrentSortButton,'gjsSortDirection')=='true' ? 1 : 0);
	}
	else {
		arguments = delimiter;
  }
	parent.serverLink.fnDo('fnCloseNotifyResult','ChangeRequestSelect.fnCloseNotify',arguments);
}

function fnCloseNotifyResult(oResult) {
  // Simply close, now server-side has noted what it needed to
	parent.fnClose() ;
}

	// Pass selected change request back to calling function
	// then close this window
function fnOpen(openAction) {
	if (!g_oSelectedRow) {
		fnSelect();
		return;
	}

	if (openAction != '') {
		var description=getAttr(g_oSelectedRow,'gjsChref')+' '+getAttr(g_oSelectedRow,'gjsName')
		openAction += '("' + gjsBase.fnAddSlashes(getAttr(g_oSelectedRow,'gjsChref')) + '","' + gjsBase.fnAddSlashes(description) + '")'
		eval(openAction);
	}
	fnCloseNotify();
}


	// New item
function fnNew(newAction) {
	if (newAction != '') {
		newAction += '("")'
		eval(newAction);
	}
	fnCloseNotify();
}


	// Clear the search fields
function fnClear() {
	frmMain.txtChangeRequest.value = '';
	frmMain.txtOwnerUserId.value = '';
  $('#txtChangeRequestType').scombobox('val','');
  $('#txtChangeRequestStatus').scombobox('val','');
	frmMain.txtSearchText.value = '';
	if (typeof(Custom)!="undefined") Custom.fnClear()
	fnSelectRow(null);
}


	// Select change requests that meet selection criteria
function fnSelect() {
	var arguments;
	frmMain.cmdOpen.disabled=true;
	document.getElementById('divSelectTable').innerHTML = '<div id=divInfo><img src="vcm_info.gif"><p>Fetching selection from server...</p></div>';

	arguments  = user ;
	arguments += delimiter + frmMain.txtChangeRequest.value;
	arguments += delimiter + frmMain.txtOwnerUserId.value;
	arguments += delimiter + $('#txtChangeRequestType').scombobox('val');
	arguments += delimiter + $('#txtChangeRequestStatus').scombobox('val');
	arguments += delimiter + frmMain.txtSearchText.value;
	if (GjsTableSorter.g_oCurrentSortButton) {
		arguments += delimiter + GjsTableSorter.g_oCurrentSortButton.textContent;
		arguments += delimiter + (getAttr(GjsTableSorter.g_oCurrentSortButton,'gjsSortDirection')=='true' ? 1 : 0);
	}
	else {
		arguments += delimiter;
		arguments += delimiter;
  }
  
  // Add any custom search field values
  arguments += delimiter;
	if (typeof(Custom)!="undefined") arguments += Custom.fnArguments()

	parent.serverLink.fnDo('fnSelectResult','ChangeRequestSelect.fnSelect',arguments);
}

function fnSelectResult(oResult) {
  var el;
  sSortCaption = GjsTableSorter.g_oCurrentSortButton.textContent;
  bSortDirection = (getAttr(GjsTableSorter.g_oCurrentSortButton,'gjsSortDirection')=='true');
	document.getElementById('divSelectHeading').innerHTML=oResult.getElementById('divSelectHeading').innerHTML;
	document.getElementById('divSelectTable').innerHTML=oResult.getElementById('divSelectTable').innerHTML;
	fnTriggerSort(sSortCaption,bSortDirection);
	fnSelectRow(null);
	frmMain.cmdOpen.disabled=false;
	el = document.getElementById('tabSelect').firstElementChild;
	if (el) el.focus();
}

	// When focus is received on a row then highlight it.
function fnSelectRow(oRow) {
	if (g_oSelectedRow) {
		g_oSelectedRow.className='';
		g_oSelectedRow=null;
	}
	if (oRow) {
		oRow.className='selectedRow';
		g_oSelectedRow=oRow;
		frmMain.cmdOpen.accessKey='O';
		frmMain.cmdOpen.value='Open';
		frmMain.cmdOpen.title='Open the chosen item';
	}
	else {
		frmMain.cmdOpen.accessKey='S';
		frmMain.cmdOpen.value='Search';
		frmMain.cmdOpen.title='Select items matching the filter field values';
	}	
}

	// When the Change Request type is changed set the Status list to the appropriate
	// option list.
function fnChangeType() {
	fnChangeSelection();
	//
	oHiddenStatus=document.getElementById("txtChangeRequestStatusFor"+$('#txtChangeRequestType').scombobox('val'));
	//
	// If no matching status list then reset the combo and finish
	if (!oHiddenStatus) {
    $('#txtChangeRequestStatus').scombobox('clear');
		return;
	}
	//
	// Replace options list from hidden select object
  $('#txtChangeRequestStatus').scombobox('options', {sort: false});
	$('#txtChangeRequestStatus').scombobox('fill',oHiddenStatus.options);
}	


	// If the selection parameters are changed then deselect and current selection
	// and reset the caption on the open button
function fnChangeSelection() {
	fnSelectRow(null);
}


function fnHelp() {
	winHelp=window.open('WebDoc/docs/index.html','vcmHelp',winHelpProperties) ;
	winHelp.focus();
}


	// Handle key down events
function fnKeyDown(event) {

  var elem=event.srcElement || event.target
  
  // Look for Escape key
  if (event.keyCode==27) {
    fnClose();
    return;
  }

	//
	// If focus is on a row and the user presses Cursor down or Cursor up then set focus on
	// the next or previous row in the table.
	if (elem.nodeName=='TR') {
		if (event.keyCode==40) {
			if (elem.nextElementSibling) elem.nextElementSibling.focus();
			return false;
		}
		if (event.keyCode==38) {
			if (elem.previousElementSibling) elem.previousElementSibling.focus();
			return false;
		}
		if (event.keyCode==36) { //Home
			elem.parentNode.firstElementChild.focus();
			return false;
		}
		if (event.keyCode==35) { //End
			elem.parentNode.lastElementChild.focus();
			return false;
		}
	}
}

function fnOnLoad() {
	// Invoked from the body onload event, to do some of the tasks
  
  // Ensure that focus on the combos will turn the Open button into the Select button
  $('#txtChangeRequestType, #txtChangeRequestStatus').scombobox('focus', function(){
    fnChangeSelection()
  });
  
  Form.fnAutoSize(); 
}

function fnUnload() {
	// Close child windows
	if (winHelp) winHelp.close();
}

	// Trigger sorting of the column with sCaption, sorting in bDirection
function fnTriggerSort(sCaption,bDirection) {
  bDirection = ((bDirection==0) ? false : true);
  arrCells=document.getElementById('divSelectHeading').getElementsByTagName('td')
  arrCells=$('#divSelectHeading td .caption')
  //
  for (i=0; i<arrCells.length; i++) {
    //
    if (arrCells[i].textContent==sCaption) {
      arrCells[i].onclick.apply(arrCells[i]);
      if (GjsTableSorter.g_bDirection != bDirection) fnTriggerSort(sCaption,bDirection);
      break;
    }
  }
}

window.onunload = fnUnload;
document.onkeydown = fnKeyDown;
