<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- Object: vcmfLocationClass.xsl/1.1 -->

<!-- This stylesheet transforms an xml formatted document into its corresponding global node representation -->
<!-- Location Classes -->

<!-- Global node and data -->
<xsl:template match="locationClass">
^%vcmf("lclass","<xsl:value-of select='@locationClass'/>")
0\<xsl:value-of select='@description'/>\<xsl:value-of select='@revision'/>\<xsl:value-of select='@accessCodes'/>
<xsl:apply-templates />
</xsl:template>

<xsl:template match="locationClass/location">
<xsl:variable name='sequence'>
  <xsl:choose>
    <xsl:when test='@sequence'>
      <xsl:value-of select='@sequence'/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select='1000+position()'/>  
    </xsl:otherwise>
  </xsl:choose>
</xsl:variable>
^%vcmf("lclass","<xsl:value-of select='../@locationClass'/>","location","<xsl:value-of select='$sequence'/>")
<xsl:value-of select='.'/>
</xsl:template>

</xsl:stylesheet>
