//vc/ VC/m physical locations Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    PhysicalLocation.js
//vc/ Component: T.PhysicalLocation.js


	// Physical location Class
PhysicalLocation = {}

PhysicalLocation.Current=Disabled;
PhysicalLocation.windowProperties  = 'left=50,top=50,width=500,height=500,toolbar=no';
PhysicalLocation.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';

	// Public - Display List of physical locations and make this the active folder
PhysicalLocation.fnList = function() {
	//
	SelectedClass=PhysicalLocation
	Class.fnUnselect()
	//
	ServerLink.fnDo('PhysicalLocation.fnListResult','PhysicalLocation.fnList','')
}

PhysicalLocation.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
PhysicalLocation.fnSelect = function(oCell) {
	Class.fnSelect(PhysicalLocation,oCell);
}


	// Public - Open physical location
PhysicalLocation.fnOpen = function(sPhysicalLocation) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('PhysicalLocation.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sPhysicalLocation) ;
	//
	// Open physical location window
	winPhysicalLocation=window.open(url,'_blank',PhysicalLocation.windowProperties) ;
	winPhysicalLocation.focus();
}

	// Public - Delete a physical location
PhysicalLocation.fnDelete = function(sPhysicalLocation) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete "+sPhysicalLocation+" ?")) return;
	//
	arguments = sPhysicalLocation+delimiter;
	//
	parent.serverLink.fnDo('PhysicalLocation.fnDeleteResult','PhysicalLocation.fnDelete',arguments);
}

PhysicalLocation.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	PhysicalLocation.fnList()
}

  // Refresh physical location
PhysicalLocation.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,'gjsParentId')
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,'gjsRowId')+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,'gjsItem')
	arguments += '\002' + getAttr(oMain,'gjsRowId')
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,'gjsRowId')+'body').parentNode,'gjsReferenceHeadingId')
	//
	return arguments
}

PhysicalLocation.fnRefresh = function(arguments)   {
  //
  ServerLink.fnDo('PhysicalLocation.fnRefreshResult','PhysicalLocation.fnRefresh',arguments)
}

PhysicalLocation.fnRefreshResult = function(oResult) {
  gjsTree.fnRefreshRows("divMainBody",oResult)
  gjsTree.fnDeleteRows("divRowDelete",oResult)
}


PhysicalLocation.Item = {

 fnDelete: function() {
	if (typeof(PhysicalLocation.Current)=='undefined') return;
	PhysicalLocation.fnDelete(getAttr(PhysicalLocation.selectedCell,'gjsItem'));
 },
 
	// Public - open selected physical location (if there is one)
 fnOpen: function() {
	if (typeof(PhysicalLocation.Current)=='undefined') return;
	PhysicalLocation.fnOpen(getAttr(PhysicalLocation.selectedCell,'gjsItem'));
 }
}
