//vc/ VC/m Device Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    Device.js
//vc/ Component: T.Device.js


	// Device Class
Device = {}
Device.Current=Disabled;
Device.windowProperties  = 'left=50,top=50,width=550,height=650,toolbar=no';
Device.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';

	// Public - Display List of Devices and make this the active folder
Device.fnList = function() {
	SelectedClass=Device;
	Class.fnUnselect();
	//
	var html;
	html  = "<table border='0' class='layoutTable' width='1000'>"
	html += "<tr>"
	html += "<td width='16' height='14'></td>";
	html += "<td width='25'></td>";
	//
	html += "<td width='150' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,2)'>"
	html += "Printer Type"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='100' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,3)'>"
	html += "Page Width"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	html += "</td>"
	//
	html += "<td width='100' class='caption' onclick='GjsTableSorter.fnSort(this,resultsTableBody,4)'>"
	html += "Page Length"
	html += "<img class='sortIcon' src='gjsSortNormal.gif'>"
	//
	html += "<td width='*'></td>";
	html += "</tr>"
	html += "</table>"
	divMainHead.innerHTML=html; 
	fnRunMain("Device.fnList",""); 
}

	// Private - Invoked when an item is selected on the list
Device.fnSelect = function(oCell) {
	Class.fnSelect(Device,oCell);
}


	// Public - Open new Device window
Device.fnNew = function() {
	fnRunWindow("Device.fnNew",Device.windowProperties); 
}

	// Public - Open Device
Device.fnOpen = function(sDevice) {
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Device.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sDevice) ;
	//
	// Open Device window
	winDevice=window.open(url,'_blank',Device.windowProperties) ;
	winDevice.focus();
}

	// Public - Delete a Device
Device.fnDelete = function(sDevice) {
	var arguments;
	//
	if (!confirm("Are you sure you want to delete "+sDevice+" ?")) return;
	//
	arguments = user;
	arguments += delimiter + sDevice;
	//
	parent.serverLink.fnDo('Device.fnDeleteResult','Device.fnDelete',arguments);
}

Device.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	Device.fnList()
}

Device.Item = {

 fnDelete: function() {
	if (typeof(Device.Current)=='undefined') return;
	Device.fnDelete(getAttr(Device.selectedCell,'gjsItem'));
 },
	// Public - open selected Device (if there is one)
 fnOpen: function() {
	if (typeof(Device.Current)=='undefined') return;
	Device.fnOpen(getAttr(Device.selectedCell,'gjsItem'));
 }
}

