//vc/ VC/m Menu Class
//vc/ Copyright 1999,2004 George James
//vc/ Object:    Menu.js
//vc/ Component: T.Menu.js


	// Menu Class
Menu = {}

Menu.Current=Disabled;
Menu.windowProperties  = 'left=50,top=50,width=770,height=520,toolbar=no';
Menu.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of menus and make this the active folder
Menu.fnList = function() {
	//
	SelectedClass=Menu;
	Class.fnUnselect();
	//
	ServerLink.fnDo('Menu.fnListResult','Menu.fnList','')
}

Menu.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Public - Open new Menu window
Menu.fnNew = function() {
	fnRunWindow("Menu.fnNew",Menu.windowProperties); 
}

	// Public - Open Menu
Menu.fnOpen = function(sMenu) {
	;
	var url;
	;
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Menu.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sMenu) ;
	;
	// Open window
	winChref=window.open(url,'_blank',Menu.windowProperties) ;
	winChref.focus();
}

	// Public - Copy Menu
Menu.fnCopy = function(sMenu) {
	;
	var url;
	;
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Menu.fnCopy') ;
	url += '&selectedItem=' + encodeURIComponent(sMenu) ;
	;
	// Open window
	winChref=window.open(url,'_blank',Menu.windowProperties) ;
	winChref.focus();
}


	// Public - Arguments for Refresh Menu
Menu.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,"gjsParentId")
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,"gjsRowId")+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,"gjsItem")
	arguments += '\002' + getAttr(oMain,"gjsRowId")
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,"gjsRowId")+'body').parentNode,"gjsReferenceHeadingId")
	//
	return arguments
}


	// Public - Refresh Menu
Menu.fnRefresh = function(arguments)   {
	//
	ServerLink.fnDo('Menu.fnRefreshResult','Menu.fnRefresh',arguments)
}


Menu.fnRefreshResult = function(oResult) {
	gjsTree.fnRefreshRows("divMainBody",oResult)
	gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Public - Delete an item
Menu.fnDelete = function(sMenu) {
	;
	var arguments;
	;
	if (!confirm("Are you sure you want to delete "+sMenu+" ?")) return;
	;
	arguments = sMenu;
	;
	parent.serverLink.fnDo('Menu.fnDeleteResult','Menu.fnDelete',arguments);
}


Menu.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	Menu.fnList();
}

Menu.Item = {}

Menu.Item.fnDelete = function() {
	if (typeof(Menu.Current)=='undefined') return;
	Menu.fnDelete(getAttr(Menu.selectedCell,"gjsItem"));
}
	// Public - open selected item (if there is one)
Menu.Item.fnOpen = function() {
	if (typeof(Menu.Current)=='undefined') return;
	Menu.fnOpen(getAttr(Menu.selectedCell,"gjsItem"));
}
	// Public - copy selected item (if there is one)
Menu.Item.fnCopy = function() {
	if (typeof(Menu.Current)=='undefined') return;
	Menu.fnCopy(getAttr(Menu.selectedCell,"gjsItem"));
}

